//+------------------------------------------------------------------+
//|                                                        Bears.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property  indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_width1 4
#property indicator_width2 2



extern int BullBearPeriod = 50;
extern int Price          = PRICE_CLOSE;

double BearsBuffer[];
double BullsBuffer[];
double TempBuffer[];
double alpha[];
double prices[];
string short_name;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   IndicatorBuffers(3);
  
   
   SetIndexBuffer(0,BearsBuffer); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,short_name);
   SetIndexBuffer(1,BullsBuffer); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,short_name);
   SetIndexBuffer(2,TempBuffer);
   
   
   short_name="non lag BullBear("+BullBearPeriod+")";
   IndicatorShortName(short_name);
   
    IndicatorDigits(Digits);
   
   return(0);
  }
//+------------------------------------------------------------------+
//|non lag Bears Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
  int    limit, i, r; 
  int    counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--;
  limit = MathMin(Bars-counted_bars,Bars-1);
  if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
           
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
   prices[r]      = iMA(NULL,0,1,0,MODE_SMA,Price,i);
   TempBuffer[i]  = iNoLagMa(alpha,prices,1,BullBearPeriod ,i,r);
   BearsBuffer[i] = Low[i]-TempBuffer[i];
   BullsBuffer[i] = High[i]-TempBuffer[i];
   }

   return(0);
  }
//+------------------------------------------------------------------+

#define Pi 3.1415926535

//
//
//
//
//

double  values[][3];
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double &alpha[], double &price[], int forvalue, int length, int i, int r)
{
   int forValue = forvalue-1;
   if (length<3) return(price[r]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alpha,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alpha[k]                   = g * beta;
            values[forValue][_weight] += alpha[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alpha[k]*price[r-k];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}